#!/usr/bin/perl

IRC::print("\cB\cC4BX-Who \cC7v1.2\cO by \cB\cC10Z\cC3irias\cO loading ...");

IRC::register("BX-Who","1.2","","");
IRC::add_message_handler("352","who_collect");
IRC::add_message_handler("315","who_print");
IRC::add_command_handler("WHO","who_cmd");
my @who_reply = ();
my $chanlen = 0;
my $nicklen = 0;
my $who_query = "";
my $activechan = "";
my $activeserv = "";

sub who_collect {
  my $line = shift;
  $line =~ /:.*(\*|#[^ ]*) ([^ ]+) ([^ ]+) [^ ]+ ([^ ]+) ([^ ]+) :[^ ]+ (.*)$/;
  @who_reply = (@who_reply,"$1 $4 $5 $2 $3 $6");
  if ($chanlen<length($1)) {
    $chanlen=length($1);
  }
  if ($nicklen<length($4)) {
    $nicklen=length($4);
  }
  return 1;
}

sub who_print {
  my $end="-";
  while(length($end)<length($who_query)) {
    $end.="-";
  }
  IRC::print_with_channel("\cC9 --------[\cC4 who \cO\cB$who_query\cO \cC3]-----------\cC14-----------------",$activechan,$activeserv);
  foreach (@who_reply) {
    /([^ ]+) ([^ ]+) ([^ ]+) ([^ ]+) ([^ ]+) (.*)/;
    my $chan=sprintf("%-*s",$chanlen,$1);
    my $nick=sprintf("%-*s",$nicklen,$2);
    my $flag=sprintf("%-3s",$3);
    IRC::print_with_channel("\cC9| \cC7$chan\cO \cB$nick\cO \cC10$flag\cO $4\cC4\@\cO$5 \cC14(\cO$6\cC14)\cO",$activechan,$activeserv);
  }
  IRC::print_with_channel("\cC9 ----------------$end\cC3-----------\cC14-----------------",$activechan,$activeserv);
  @who_reply = ();
  $chanlen = 0;
  $nicklen = 0;
  return 1;
}

sub who_cmd {
  $who_query = shift;
  $activechan=IRC::get_info(2);
  if ($who_query =~ /^$/) {
    $who_query = $activechan;
  }
  if ($who_query =~ /^\*$/) {
    $who_query = "+u *";
  }
  IRC::send_raw("WHO $who_query\r\n");
  return 1;  
}

1;
#end
